'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var ConsoleLogger = (function () {
  function ConsoleLogger() {
    var prefix = arguments.length <= 0 || arguments[0] === undefined ? 'i18next:' : arguments[0];

    _classCallCheck(this, ConsoleLogger);

    this.prefix = prefix;
    this.type = 'logger';
  }

  _createClass(ConsoleLogger, [{
    key: 'log',
    value: function log(args) {
      this._output('log', args);
    }
  }, {
    key: 'warn',
    value: function warn(args) {
      this._output('warn', args);
    }
  }, {
    key: 'error',
    value: function error(args) {
      this._output('error', args);
    }
  }, {
    key: '_output',
    value: function _output(type, args) {
      if (typeof args[0] === 'string') args[0] = this.prefix + ' ' + args[0];
      if (console && console[type]) console[type].apply(console, Array.prototype.slice.call(args));
    }
  }]);

  return ConsoleLogger;
})();

ConsoleLogger.type = 'logger';

var Logger = (function () {
  function Logger(ConcreteLogger, options) {
    _classCallCheck(this, Logger);

    this.subs = [];
    this.init(ConcreteLogger, options);
  }

  _createClass(Logger, [{
    key: 'init',
    value: function init(ConcreteLogger) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      this.ConcreteLogger = ConcreteLogger ? ConcreteLogger : ConsoleLogger;
      this.logger = new this.ConcreteLogger(options.prefix);
      this.options = options;
      this.debug = options.debug === false ? false : true;
    }
  }, {
    key: 'setDebug',
    value: function setDebug(bool) {
      this.debug = bool;
      this.subs.forEach(function (sub) {
        sub.setDebug(bool);
      });
    }
  }, {
    key: 'log',
    value: function log() {
      if (this.debug) this.logger.log(arguments);
    }
  }, {
    key: 'warn',
    value: function warn() {
      if (this.debug) this.logger.warn(arguments);
    }
  }, {
    key: 'error',
    value: function error() {
      this.logger.error(arguments);
    }
  }, {
    key: 'deprecate',
    value: function deprecate() {
      if (typeof args[0] === 'string') args[0] = 'WARNING DEPRECATED: ' + args[0];
      if (this.debug) this.logger.warn(arguments);
    }
  }, {
    key: 'create',
    value: function create(moduleName) {
      var sub = new Logger(this.ConcreteLogger, _extends({ prefix: this.logger.prefix + ':' + moduleName + ':' }, this.options));
      this.subs.push(sub);

      return sub;
    }

    // createInstance(options = {}) {
    //   return new Logger(options, callback);
    // }

  }]);

  return Logger;
})();

;

exports['default'] = new Logger();
module.exports = exports['default'];